{
===============================================================================
  Copyright (©) 2001. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 01-10-2001
  Versión actual: 1.0.3
  Fecha versión actual: 11-05-2002
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
    07-04-2002    Se ha adaptado el frame para transacción única.

    09-04-2002    Sustituir las constantes IDYES/IDNO por IDOK.

    11-05-2002    P215. Copia de presupuestos.
===============================================================================
}

unit RdxFramePresupuestos;

{$I ..\COMPILE.INC}

interface

uses
  Consts, Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RdxFrame, RdxDBFrame, IBCustomDataSet, Tipos, IBDataBase, DB;

type
  TRdxFramePresupuestos = class(TRdxDBFrame)
  private
    FTablaPresupuestos : TIBDataSet;
    FTablaDetallesPresupuestos : TIBDataSet;
  protected
    FCodigoPresupuesto : Variant;
    FCodigoPresupuestoOrigen : Variant;
    procedure SetTablaPresupuestos (Value : TIBDataSet);
    procedure SetTablaDetallesPresupuestos (Value : TIBDataSet);
    procedure SetCodigoPresupuesto (Value : Variant); virtual;
    procedure SetCodigoPresupuestoOrigen(const Value: Variant);
    procedure SetContenido (NuevoFrame : TRdxFrame); override;
    function TratarCambios : integer; override;
    procedure BuscarPresupuesto; virtual;
    procedure CambiarModo(ModoAnterior, Modo : TRdxModo); override;
  public
    property TablaPresupuestos: TIBDataSet read FTablaPresupuestos write SetTablaPresupuestos;
    property TablaDetallesPresupuestos: TIBDataSet read FTablaDetallesPresupuestos write SetTablaDetallesPresupuestos;
    property CodigoPresupuesto : Variant read FCodigoPresupuesto write SetCodigoPresupuesto;
    property CodigoPresupuestoOrigen : Variant read FCodigoPresupuestoOrigen write SetCodigoPresupuestoOrigen;
    constructor Create (AOwner : TComponent); override;
  published
    property BaseDatos;
    property Transaccion;
  end;


implementation

{$R *.DFM}

uses
  IB, Mensajes, StrFunc, Literales
  {$IFDEF RDX_D6}, Variants{$ENDIF};  

{ TRdxFramePresupuestos }

constructor TRdxFramePresupuestos.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCodigoPresupuesto := NULL;
  FTablaPresupuestos := NIL;
  FTablaDetallesPresupuestos := NIL;
end;

function TRdxFramePresupuestos.TratarCambios : integer;
begin
  if (TablaPresupuestos.Modified = True) or
     ((TablaDetallesPresupuestos <> NIL) and (TablaDetallesPresupuestos.Modified = True)) then
  begin
    case VerMensajePregunta(msgGuardarCambios) of
      IDCANCEL    : Result := IDCANCEL;
      IDYES       : begin
                      if (RealizarOperacion)
                      then Result := IDOK
                      else Result := IDCANCEL;
                    end;
      IDNO        : begin
                      if (DescartarOperacion)
                      then Result := IDOK
                      else Result := IDCANCEL;
                    end;
    end
  end
  else Result := IDOK;
end;

procedure TRdxFramePresupuestos.SetCodigoPresupuesto(Value: Variant);
begin
  if not EsCadenaVacia (Value) then
  begin
    FCodigoPresupuesto := Value;
    BuscarPresupuesto;
  end
end;

procedure TRdxFramePresupuestos.SetContenido(NuevoFrame: TRdxFrame);
begin
  if (FContenido <> NIL) then
    if (Contenido.Name = NuevoFrame.ClassName) then
    begin
      NuevoFrame.Free;
      exit;
    end;
  inherited;
  if (TablaPresupuestos <> NIL) then
  begin
    FCodigoPresupuesto := TablaPresupuestos.FieldByName('CODIGO').Value;
    if Contenido is TRdxFramePresupuestos then
      (Contenido as TRdxFramePresupuestos).CodigoPresupuesto := FCodigoPresupuesto;
  end;
end;

procedure TRdxFramePresupuestos.CambiarModo(ModoAnterior, Modo : TRdxModo);
begin
  inherited;
  if (FModo in [Normal, Seleccionar]) then
  begin
    TablaPresupuestos.Close;
    TablaPresupuestos.Open;
  end
  else begin
    { Si estábamos en el modo Añadir y pasamos a cualquier otro modo SIEMPRE
      es necesario buscar el codigo de presupuesto que tiene el frame
      en CodigoPresupuesto (al activar el modo Añadir NO se pisa este valor con
      el código de presupuesto nuevo) }
    if (not TablaPresupuestos.Active) or (ModoAnterior = Anadir) then
      BuscarPresupuesto;
  end;
end;

procedure TRdxFramePresupuestos.SetTablaPresupuestos(Value: TIBDataSet);
begin
  if (FTablaPresupuestos <> Value) then
    FTablaPresupuestos := Value;
end;

procedure TRdxFramePresupuestos.SetTablaDetallesPresupuestos(Value: TIBDataSet);
begin
  if (FTablaDetallesPresupuestos <> Value) then
    FTablaDetallesPresupuestos := Value;
end;

procedure TRdxFramePresupuestos.BuscarPresupuesto;
begin
//
end;

procedure TRdxFramePresupuestos.SetCodigoPresupuestoOrigen(
  const Value: Variant);
begin
  if not EsCadenaVacia (Value) then
    FCodigoPresupuestoOrigen := Value;
end;

end.
